package cn.com.qmth.dp.examcloud.oe.multithread;

import java.util.HashMap;
import java.util.Map;

import org.apache.logging.log4j.ThreadContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import cn.com.qmth.dp.examcloud.oe.modules.export_questions_count.RetDto;

public abstract class Consumer<T>  extends Thread{
	private static final Logger logger = LoggerFactory.getLogger(Consumer.class);
	private Basket basket;
	
	private Map<String,RetDto> ret;
	
	private String traceId;
	
	public Consumer() {
	}
	@Override
	public void run() {
		ret=new HashMap<>();
		logger.info("*******************Consumer:"+Thread.currentThread().getId()+" start");
		try {
			while (true) {
				//先判断是否有异常结束
				if(basket.isExcuteError()) {
					break;
				}
				//取消费数据
				Object o= basket.consume();
				//判断消费数据是否是结束
				if(o instanceof EndObject) {
					break;
				}
				@SuppressWarnings("unchecked")
				T t=(T)o;
				logger.info("*******************Consumer:"+Thread.currentThread().getId()+" consume");
				//消费数据实现
				consume(t);
			}
		} catch (Exception e) {
			basket.setExcuteError(true);
			logger.error("消费线程处理出错",e);
		}finally {
			basket.countDown();
			logger.info("*******************Consumer:"+Thread.currentThread().getId()+" stop");
			ThreadContext.clearAll();
		}
	}
	public abstract void consume(T t);
	public Basket getBasket() {
		return basket;
	}
	public void setBasket(Basket basket) {
		this.basket = basket;
	}
	public String getTraceId() {
		return traceId;
	}
	public void setTraceId(String traceId) {
		this.traceId = traceId;
	}
	public Map<String, RetDto> getRet() {
		return ret;
	}
	public void setRet(Map<String, RetDto> ret) {
		this.ret = ret;
	}
	
}
